/**********************************************************************/
/**********************************************************************/
/* The GIM project                                                    */
/**********************************************************************/
/* FILENAME:         GIMcontacts.h                                    */
/* ORIGINATION DATE: 12/24/04                                         */
/* ORIGINATOR:       M Roth                                           */
/* MODULE:           contacts                                         */
/* LICENSE:          gpl (www.gnu.org/copyleft/gpl.html)              */
/**********************************************************************/
/* GIM Copyright (C)2004, 2005                                        */
/*   Darrin Smith - darrin[at]dbcservices[dot]com                     */
/*   Mark Roth - GIM[dot]mroth[at]gmail[dot]com                       */
/*   And others.                                                      */
/* GIDForums is a registered trademark                               */
/*                                                                    */
/* Find GIM at (put savannah site here)                               */
/* Discuss GIM at GIDForums[dot]com                                   */
/* Contact GIM at GIMmailer[at]gmail[dot]com                          */
/*                                                                    */
/**********************************************************************/
/*               This file is part of GIM.                            */
/* GIMcontacts is free software. You can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published  */
/* by the Free Software Foundation, either version 2 of the License,  */
/* or (at your option) any later version.                             */
/* GIMcontacts is distributed in the hope that it will be useful,     */
/* but WITHOUT ANY WARRANTY' without even the implied warranty of     */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      */
/* GNU General Public License for more details.                       */
/*                                                                    */
/* You should have received a copy of the GNU General Public License  */
/* along with GIMcontacts. If not, write to :                         */
/*       the Free Software Foundation, Inc.                           */
/*       59 Temple Place                                              */
/*       Suite 330                                                    */
/*       Boston, MA  02111-1307  USA                                  */
/*                                                                    */
/*  Licence in distribution, COPYING.txt                              */
/*                                                                    */
/**********************************************************************/
/* DESCRIPTION:                                                       */
/* This is the Fluid project file for GIMcontacts.  It was built      */
/* using the current subversion from fltk[dot]org.                    */
/* Built with svn -r4124 which includes modifications to add the GPL  */
/* notices and other types of comments.                               */
/**********************************************************************/
/**********************************************************************/


// generated by Fast Light User Interface Designer (fluid) version 1.0107

#ifndef GIMcontacts011_h
#define GIMcontacts011_h
#include <FL/Fl.H>
#include <cstdlib>
#include <cstring>
#include <FL/Fl_File_Chooser.H>
#include <FL/fl_ask.H>
#include <FL/filename.H>
#include <gim.h>
#include <gct.h>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Menu_Bar.H>
extern void cb_about_gct(Fl_Menu_*, void*);
extern void cb_about_gim(Fl_Menu_*, void*);
extern void cb_about_fltk(Fl_Menu_*, void*);
extern void cb_about_gnu(Fl_Menu_*, void*);
#include <FL/Fl_Group.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Value_Output.H>

class GCT_contact {
  char gct_name[240];
  bool gct_modified;
  bool rec_modified;
  unsigned short int record_num;
  contact *current;
public:
  GCT_contact();
private:
  Fl_Double_Window *contact_list;
  Fl_Menu_Bar *gctmenu;
  static Fl_Menu_Item menu_gctmenu[];
  static Fl_Menu_Item *submenu_file;
  static Fl_Menu_Item *menu_new;
  static Fl_Menu_Item *menu_open;
  static Fl_Menu_Item *menu_save;
  static Fl_Menu_Item *menu_saveas;
  static Fl_Menu_Item *menu_quit;
  static Fl_Menu_Item *submenu_edit;
  static Fl_Menu_Item *menu_newcontact;
  static Fl_Menu_Item *menu_deletecontact;
  static Fl_Menu_Item *menu_readonly;
  static Fl_Menu_Item *submenu_type;
  static Fl_Menu_Item *menu_personal;
  static Fl_Menu_Item *menu_business;
  static Fl_Menu_Item *menu_other;
  static Fl_Menu_Item *submenu_password;
  static Fl_Menu_Item *menu_assign;
  static Fl_Menu_Item *menu_remove;
  static Fl_Menu_Item *submenu_about;
  static Fl_Menu_Item *menu_aboutgct;
  static Fl_Menu_Item *menu_aboutgim;
  static Fl_Menu_Item *menu_aboutfltk;
  static Fl_Menu_Item *menu_aboutgnu;
  Fl_Group *group_name;
  Fl_Input *in_lname;
  Fl_Input *in_fname;
  Fl_Input *in_mname;
  Fl_Input *in_cname;
  Fl_Group *group_contactinfo;
  Fl_Input *in_home;
  Fl_Input *in_work;
  Fl_Input *in_mobil;
  Fl_Input *in_fax;
  Fl_Input *in_other1;
  Fl_Input *in_other2;
  Fl_Input *in_email;
  Fl_Input *in_url;
  Fl_Group *group_address;
  Fl_Input *in_address1;
  Fl_Input *in_address2;
  Fl_Input *in_city;
  Fl_Input *in_state;
  Fl_Input *in_zipcode;
  Fl_Input *in_country;
  Fl_Input *multi_notes;
  Fl_Group *GIM_LOGO;
  Fl_Output *out_filename;
  Fl_Output *out_type;
  Fl_Group *group_nav;
  Fl_Button *nav_home;
  Fl_Button *nav_prev;
  Fl_Value_Output *nav_view;
  Fl_Button *nav_next;
  Fl_Button *nav_end;
public:
  Fl_Output *out_gctname;
  Fl_Output *out_gctmodified;
  Fl_Output *out_recmodified;
  Fl_Output *out_recordnum;
  ~GCT_contact();
private:
  void check_mod();
  void get_filename();
  void save_contacts();
  void load_contacts();
  void modify_contact();
  void display();
  void group_hide();
  void group_show();
  inline void icb_newfile();
  static void cb_newfile(Fl_Widget*, void *user);
  inline void icb_openfile();
  static void cb_openfile(Fl_Widget*, void *user);
  inline void icb_savefile();
  static void cb_savefile(Fl_Widget*, void *user);
  inline void icb_saveas();
  static void cb_saveas(Fl_Widget*, void *user);
  inline void icb_exit();
  static void cb_exit(Fl_Widget*, void *user);
  inline void icb_addrec();
  static void cb_addrec(Fl_Widget*, void *user);
  inline void icb_delrec();
  static void cb_delrec(Fl_Widget*w, void *user);
  inline void icb_readonly();
  static void cb_readonly(Fl_Widget *w, void *user);
  inline void icb_type();
  static void cb_type(Fl_Widget *, void *user);
  inline void icb_assignPW();
  static void cb_assignPW(Fl_Widget *w, void *user);
  inline void icb_removePW();
  static void cb_removePW(Fl_Widget *w, void *user);
  static void cb_about_gct(Fl_Widget*, void*);
  static void cb_about_gim(Fl_Widget*, void*);
  static void cb_about_fltk(Fl_Widget*, void*);
  static void cb_about_gnu(Fl_Widget*, void*);
  inline void icb_navhome();
  static void cb_navhome(Fl_Widget*, void *user);
  inline void icb_navprev();
  static void cb_navprev(Fl_Widget*, void *user);
  inline void icb_navdisplay();
  static void cb_navdisplay(Fl_Widget*, void *user);
  inline void icb_navnext();
  static void cb_navnext(Fl_Widget*, void *user);
  inline void icb_navend();
  static void cb_navend(Fl_Widget*, void *user);
  inline void icb_notes();
  static void cb_notes(Fl_Widget*, void *user);
  inline void icb_lname();
  static void cb_lname(Fl_Widget*,void *user);
  inline void icb_fname();
  static void cb_fname(Fl_Widget*,void *user);
  inline void icb_mname();
  static void cb_mname(Fl_Widget*,void *user);
  inline void icb_cname();
  static void cb_cname(Fl_Widget*,void *user);
  inline void icb_homephone();
  static void cb_homephone(Fl_Widget*,void *user);
  inline void icb_workphone();
  static void cb_workphone(Fl_Widget*,void *user);
  inline void icb_faxphone();
  static void cb_faxphone(Fl_Widget*,void *user);
  inline void icb_mobilphone();
  static void cb_mobilphone(Fl_Widget*,void *user);
  inline void icb_o1phone();
  static void cb_o1phone(Fl_Widget*,void *user);
  inline void icb_o2phone();
  static void cb_o2phone(Fl_Widget*,void *user);
  inline void icb_email();
  static void cb_email(Fl_Widget*,void *user);
  inline void icb_url();
  static void cb_url(Fl_Widget*,void *user);
  inline void icb_address1();
  static void cb_address1(Fl_Widget*,void *user);
  inline void icb_address2();
  static void cb_address2(Fl_Widget*,void *user);
  inline void icb_city();
  static void cb_city(Fl_Widget*,void *user);
  inline void icb_state();
  static void cb_state(Fl_Widget*,void *user);
  inline void icb_zipcode();
  static void cb_zipcode(Fl_Widget*,void *user);
  inline void icb_country();
  static void cb_country(Fl_Widget*,void *user);
};
#endif
