/**********************************************************************/
/**********************************************************************/
/* The GIM project                                                    */
/**********************************************************************/
/* FILENAME:         gct.cpp                                          */
/* ORIGINATION DATE: 12/24/04                                         */
/* ORIGINATOR:       M Roth                                           */
/* MODULE:           contacts                                         */
/* LICENSE:          gpl (www.gnu.org/copyleft/gpl.html)              */
/**********************************************************************/
/* GIM Copyright (C)2004, 2005                                        */
/*   Darrin Smith - darrin[at]dbcservices[dot]com                     */
/*   Mark Roth - GIM[dot]mroth[at]gmail[dot]com                       */
/*   And others.                                                      */
/* GIDForums is a registered trademark                               */
/*                                                                    */
/* Find GIM at (put savannah site here)                               */
/* Discuss GIM at GIDForums[dot]com                                   */
/* Contact GIM at GIMmailer[at]gmail[dot]com                          */
/*                                                                    */
/**********************************************************************/
/*               This file is part of GIM.                            */
/* gct.cpp is free software. You can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published  */
/* by the Free Software Foundation, either version 2 of the License,  */
/* or (at your option) any later version.                             */
/* gct.cpp is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY' without even the implied warranty of     */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      */
/* GNU General Public License for more details.                       */
/*                                                                    */
/* You should have received a copy of the GNU General Public License  */
/* along with gct.cpp. If not, write to :                             */
/*       the Free Software Foundation, Inc.                           */
/*       59 Temple Place                                              */
/*       Suite 330                                                    */
/*       Boston, MA  02111-1307  USA                                  */
/*                                                                    */
/*  Licence in distribution, COPYING.txt                              */
/*                                                                    */
/**********************************************************************/
/* DESCRIPTION:                                                       */
/* This file contains helper functions for formatting text used by    */
/* GIMcontacts.  It will be rolled into the new class structure in    */
/* the near future.                                                   */
/**********************************************************************/
/**********************************************************************/
#ifndef __GCT_CPP
#define __GCT_CPP

// A custom version of this will be rolled into class GCT_contact
// as member functions called by inlined callbacks.
#include <string>
#include <gct.h>
/*
enum filter{ nobufin_clean = 0, yes_no, yes_no_cancel,letter_only,
              number_only, punct_only, printable_only, space_remove,
              lspace_remove, bspace_remove, escape_remove, upper_all,
              lower_all, upper_first, url_clean, phone_good, tab_remove,
              size_only, upper_firsts, tspace_remove };
*/
using namespace std;

string filters(string buffer, const short int filter){
     //  These are the base filters your complex filters call.
    //  This removes the recursion and some messy looping in
   //  clean_input.
    bool pass_key = false;

    for( int index = 0; index < buffer.length(); index++ ){
        switch( filter ) {
            case letter_only :
                if ( !isalpha(buffer[index]) ) {
                    buffer.erase(index, 1);
                    index --;
                }
                break;
            case number_only :
                if ( !isdigit( buffer[index]) ) {
                    buffer.erase(index, 1);
                    index --;
                }
                break;
            case punct_only :
                if ( !ispunct( buffer[index] ) ) {
                    buffer.erase(index, 1);
                    index --;
                }
                break;
            case printable_only :
                if ( !isprint(buffer[index]) ) {
                    buffer.erase(index, 1);
                    index --;
                }
                break;

            case space_remove :
                if ( isspace( buffer[index]) ) {
                    buffer.erase(index, 1);
                    index --;
                }
                break;
            case lspace_remove :
                if(isspace( buffer[index] )){
                    buffer.erase( index, 1 );
                    index --;
                }else index = buffer.length() - 1;
                break;
            case tspace_remove :
                while(isspace( buffer[buffer.length()-1] )){
                    buffer.erase( buffer.length()-1, 1 );
                }
                index = buffer.length() - 1;
                break;
            case bspace_remove :
                // User wanted to get rid of this so we get rid of last new char
                if ( (int)buffer[index] == 8) {
                    if(index > 0) {
                        buffer.erase(index - 1, 2);
                        index --;
                    }else buffer.erase(index, 1);
                    index --;
                }
                break;
            case escape_remove :
              //  If we find a 27 it is an escape and things get exciting
             //  here are my rules to remove them.
            //  Mostly of value to my CygWin environment.
                if ( (int)buffer[index] == 27 ){  // Mark sure this works MRoth [catv]
                    if ( (int)buffer[index + 4] == 126 ){
                        buffer.erase(index, 5);
                        index --;//loop will increment ++
                    }else if ( (int)buffer[index + 3] == 126 ){
                        buffer.erase(index, 4);
                        index --;//loop will increment ++
                    }else if ( ((int)buffer[index + 1] == 91)
                            && ((int)buffer[index + 2] == 91) ){
                        buffer.erase(index, 4);
                        index --;//loop will increment ++
                    }else if ( ((int)buffer[index + 1] == 91) ){
                        buffer.erase(index, 3);
                        index --;
                    }
                }
                break;
            case upper_all :
                if( isalpha(buffer[index]) ) buffer[index] = toupper(buffer[index]);
                break;
            case lower_all :
                if( isalpha(buffer[index]) ) buffer[index] = tolower(buffer[index]);
                break;
            case upper_first :
                if(isalpha( buffer[index] )){
                    buffer[index] = toupper(buffer[index]);
                    index = buffer.length() - 1;
                }else index = buffer.length() - 1;
                break;
            case upper_firsts :
                if(isalpha( buffer[0] ) && pass_key == false){
                    buffer[0] = toupper(buffer[0]);
                    pass_key = true;
                }
                if(isspace(buffer[index]) && isalpha(buffer[index+1])){
                    index ++;
                    buffer[index]=toupper(buffer[index]);
                }
                break;
            case tab_remove :
                if ( (int)buffer[index] == 9) {
                    buffer.erase( index, 1 );
                    index --;
                }
                break;
            default :
                break;
        }
    }
    return buffer;
}
//  string clean_input (string buffer, const short int filter, const short int out_length );
//  Takes an unknown input and returns it clean, safe and hopefully more useful.
//  clean_input is the call that will be made from the interface of gim module.
//  It will contact the GUI of choice and open the database accordingly.
//  Module functions for accessing the db are located in gct_data.cpp

using namespace std;
char* clean_input (char *cbuffer, const short int filter, const short int out_length ){
     //  This will handle your input filtering needs for getting
    //  reliable formatted input and should make it easy
   //  to add complex text filtering without much effort.
    string buffer = cbuffer;

    switch ( filter ) {
              // These are the simple filters used by the complex filters.
             // A complex filter is merely a filter that calls more than
            // one filter to accomplish its task.  The simple filters are
           // called here to add output length correction. Just bumped
          // to filter ( buffer, filter_name ).  The same functionality
         // can be achieved by calling the simple filter directly and
        // then calling size_only.
        case letter_only :
        case number_only :
        case punct_only :
        case printable_only :
        case space_remove :
        case lspace_remove :
        case tspace_remove :
        case bspace_remove :
        case escape_remove :
        case upper_all :
        case lower_all :
        case upper_first :
        case upper_firsts :
        case tab_remove :
            buffer = filters(buffer, filter);
            break;
        case size_only :
            break;
        case nobufin_clean :
            /********************************************************/
            //  This needs some explaination. It started as a very  //
            //  simple getline() excersise and ended up here.       //
            //    While testing char arrays I found lots of extra   //
            //    unbuffered junk from escape sequences. This will  //
            //    rid you of the ones I know about.  Only problem   //
            //    is if you enter <esc> <[> <[> <shift A> it is     //
            //    removed as if you hit f1,  Oh well...             //
            /********************************************************/

            buffer = filters( buffer,escape_remove );
            buffer = filters( buffer,tab_remove );
            buffer = filters( buffer,bspace_remove );
            buffer = filters( buffer,printable_only );
             // Is it possible to have a non-printable char
            // effect the backspace removal ???
            break;
        case url_clean :
            break;
        case phone_good :
            if(buffer.length()==7){
                buffer.insert(3,"-");
            }else if(buffer.length()==10){
                buffer.insert(0,"(");
                buffer.insert(4,")");
                buffer.insert(8,"-");
            }
            break;
    }
    //  This will trim to length
    if(out_length < buffer.length() ) buffer.erase(out_length);
    strcpy(cbuffer,buffer.c_str());
    return cbuffer;
}
#endif
